# Method: projects.locations.caPools.certificates.create

- [HTTP request](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create#body.request_body)
- [Response body](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create#body.aspect)

Create a new `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate` in a given Project, Location from a particular `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`.

### HTTP request

`POST https://privateca.googleapis.com/v1/{parent=projects/*/locations/*/caPools/*}/certificates`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The resource name of the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool` associated with the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate`, in the format `projects/*/locations/*/caPools/*`. Authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions on the specified resource `parent`: - `privateca.certificates.create` - `privateca.certificates.createForSelf` |

### Query parameters

| Parameters ||
|---|---|
| `certificateId` | `string` Optional. It must be unique within a location and match the regular expression `[a-zA-Z0-9_-]{1,63}`. This field is required when using a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority` in the Enterprise `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority.FIELDS.tier`, but is optional and its value is ignored otherwise. |
| `requestId` | `string` Optional. An ID to identify requests. Specify a unique request ID so that if you must retry your request, the server will know to ignore the request if it has already been completed. The server will guarantee that for at least 60 minutes since the first request. For example, consider a situation where you make an initial request and the request times out. If you make the request again with the same request ID, the server can check if original operation with the same request ID was received, and if so, will ignore the second request. This prevents clients from accidentally creating duplicate commitments. The request ID must be a valid UUID with the exception that zero UUID is not supported (00000000-0000-0000-0000-000000000000). |
| `validateOnly` | `boolean` Optional. If this is true, no `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate` resource will be persisted regardless of the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`'s `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool.FIELDS.tier`, and the returned `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate` will not contain the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate.FIELDS.pem_certificate` field. |
| `issuingCertificateAuthorityId` | `string` Optional. The resource ID of the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority` that should issue the certificate. This optional field will ignore the load-balancing scheme of the Pool and directly issue the certificate from the CA with the specified ID, contained in the same `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool` referenced by `parent`. Per-CA quota rules apply. If left empty, a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority` will be chosen from the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool` by the service. For example, to issue a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate` from a Certificate Authority with resource name "projects/my-project/locations/us-central1/caPools/my-pool/certificateAuthorities/my-ca", you can set the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create#body.PATH_PARAMETERS.parent` to "projects/my-project/locations/us-central1/caPools/my-pool" and the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create#body.QUERY_PARAMETERS.issuing_certificate_authority_id` to "my-ca". |

### Request body

The request body contains an instance of `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate`.

### Response body

If successful, the response body contains a newly created instance of `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).